[PATCH] Trapping exit in tests, using return for errors
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5
6 # For repeatability, reset the environment to known value.
7 LANG=C
8 PAGER=cat
9 TZ=UTC
10 export LANG PAGER TZ
11 unset AUTHOR_DATE
12 unset AUTHOR_EMAIL
13 unset AUTHOR_NAME
14 unset COMMIT_AUTHOR_EMAIL
15 unset COMMIT_AUTHOR_NAME
16 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
17 unset GIT_AUTHOR_DATE
18 unset GIT_AUTHOR_EMAIL
19 unset GIT_AUTHOR_NAME
20 unset GIT_COMMITTER_EMAIL
21 unset GIT_COMMITTER_NAME
22 unset GIT_DIFF_OPTS
23 unset GIT_DIR
24 unset GIT_EXTERNAL_DIFF
25 unset GIT_INDEX_FILE
26 unset GIT_OBJECT_DIRECTORY
27 unset SHA1_FILE_DIRECTORIES
28 unset SHA1_FILE_DIRECTORY
29
30 # Each test should start with something like this, after copyright notices:
31 #
32 # test_description='Description of this test...
33 # This test checks if command xyzzy does the right thing...
34 # '
35 # . ./test-lib.sh
36
37 error () {
38         echo "* error: $*"
39         exit 1
40 }
41
42 say () {
43         echo "* $*"
44 }
45
46 test "${test_description}" != "" ||
47 error "Test script did not set test_description."
48
49 while test "$#" -ne 0
50 do
51         case "$1" in
52         -d|--d|--de|--deb|--debu|--debug)
53                 debug=t; shift ;;
54         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
55                 immediate=t; shift ;;
56         -h|--h|--he|--hel|--help)
57                 echo "$test_description"
58                 exit 0 ;;
59         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
60                 verbose=t; shift ;;
61         *)
62                 break ;;
63         esac
64 done
65
66 exec 5>&1
67 if test "$verbose" = "t"
68 then
69         exec 4>&2 3>&1
70 else
71         exec 4>/dev/null 3>/dev/null
72 fi
73
74 test_failure=0
75 test_count=0
76
77
78 # You are not expected to call test_ok_ and test_failure_ directly, use
79 # the text_expect_* functions instead.
80
81 test_ok_ () {
82         test_count=$(expr "$test_count" + 1)
83         say "  ok $test_count: $@"
84 }
85
86 test_failure_ () {
87         test_count=$(expr "$test_count" + 1)
88         test_failure=$(expr "$test_failure" + 1);
89         say "FAIL $test_count: $1"
90         shift
91         echo "$@" | sed -e 's/^/        /'
92         test "$immediate" = "" || exit 1
93 }
94
95
96 test_debug () {
97         test "$debug" = "" || eval "$1"
98 }
99
100 test_run_ () {
101         trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
102         eval >&3 2>&4 "$1"
103         eval_ret="$?"
104         trap - exit
105         return 0
106 }
107
108 test_expect_failure () {
109         test "$#" = 2 ||
110         error "bug in the test script: not 2 parameters to test-expect-failure"
111         say >&3 "expecting failure: $2"
112         test_run_ "$2"
113         if [ "$?" = 0 -a "$eval_ret" != 0 ]
114         then
115                 test_ok_ "$1"
116         else
117                 test_failure_ "$@"
118         fi
119 }
120
121 test_expect_success () {
122         test "$#" = 2 ||
123         error "bug in the test script: not 2 parameters to test-expect-success"
124         say >&3 "expecting success: $2"
125         test_run_ "$2"
126         if [ "$?" = 0 -a "$eval_ret" = 0 ]
127         then
128                 test_ok_ "$1"
129         else
130                 test_failure_ "$@"
131         fi
132 }
133
134 test_done () {
135         case "$test_failure" in
136         0)      
137                 # We could:
138                 # cd .. && rm -fr trash
139                 # but that means we forbid any tests that use their own
140                 # subdirectory from calling test_done without coming back
141                 # to where they started from.
142                 # The Makefile provided will clean this test area so
143                 # we will leave things as they are.
144
145                 say "passed all $test_count test(s)"
146                 exit 0 ;;
147
148         *)
149                 say "failed $test_failure among $test_count test(s)"
150                 exit 1 ;;
151
152         esac
153 }
154
155 # Test the binaries we have just built.  The tests are kept in
156 # t/ subdirectory and are run in trash subdirectory.
157 PATH=$(pwd)/..:$PATH
158
159 # Test repository
160 test=trash
161 rm -fr "$test"
162 mkdir "$test"
163 cd "$test"
164 git-init-db 2>/dev/null || error "cannot run git-init-db"